from math import *
posIo = 4
laps = 1

def euler2mat(rot_x,rot_y,rot_z):
	A = cos(rot_x)
	B = sin(rot_x)
	C = cos(rot_y)
	D = sin(rot_y)
	E = sin(rot_z + pi/2)
	F = cos(rot_z + pi/2)
	AD = A * D
	BD = B * D
	ori = [[C*E,-C*F,-D],[-BD*E+A*F,BD*F+A*E,-B*C],[AD*E+B*F,-AD*F+B*E,A*C]]
	return (ori)

def Cross(Vector1,Vector2):
	VNormal = []       #The vector that hold the croos product
	VNormal[0] = ((Vector1[1] * Vector2[2]) - (Vector1[2] * Vector2[1])) #The x value
	VNormal[1] = ((Vector1[2] * Vector2[0]) - (Vector1[0] * Vector2[2])) #The Y value
	VNormal[2] = ((Vector1[0] * Vector2[1]) - (Vector1[1] * Vector2[0])) #The Z value
	return VNormal

def Magnitude(VNormal):
	return sqrt((VNormal[0] * VNormal[0]) +  (VNormal[1] * VNormal[1]) + (VNormal[2] * VNormal[2]))


def Dot(Vector1,Vector2):
	return ((Vector1[0] * Vector2[0]) + (Vector1[1] * Vector2[1]) +(Vector1[2] * Vector2[2]))

def AngleBetweenVectors(Vector1,Vector2):
	dotProduct = Dot(Vector1,Vector2)
	VectorsMagnitude = Magnitude(Vector1) * Magnitude(Vector2)
	Angle = acos ( dotProduct / VectorsMagnitude)
	return Angle

def Normalize(VNormal):
	magnitude = Magnitude(VNormal) #Vector magnitude
	VNormal[0] = VNormal[0] / magnitude
	VNormal[1] = VNormal[1] / magnitude
	VNormal[2] = VNormal[2] / magnitude
	return VNormal  # return the same vector with length = 1

def distance(Point1,Point2):
	distance_x = (Point2[0] - Point1[0]) * (Point2[0] - Point1[0]) 
	distance_y = (Point2[1] - Point1[1]) * (Point2[1] - Point1[1])
	distance_z = (Point2[2] - Point1[2]) * (Point2[2] - Point1[2])
	distance = sqrt(distance_x + distance_y + distance_z)
	return distance